#include <bits/stdc++.h>

using namespace std;

int main() {
	
	long long int n,q,i,j,rez=0,brp=0;
	
	scanf("%lld %lld", &n,&q);
	
	long long d[n],p[n],b[q];
	
	for(i=0;i<n;i++){
		scanf("%lld",&d[i]);
		scanf("%lld",&p[i]);
	}
	
	for(j=0;j<q;j++){
		scanf("%lld",&b[j]);		
	}
	for(j=0;j<q;j++){
			
		while(b[j]>0){
			for(i=0;i<n;i++){
				if(b[j]==d[i]){
					brp=brp+p[i];
				}	
				
				
			}
			if(brp>0){
				rez++;
				brp--;
			}
			b[j]--;
		}
		
		cout<<rez;
	}

    return 0;
}